<script lang="ts">
import { DemoModal } from '../common/index.vue';
export default {
  name: 'CallOut',
  components: { DemoModal },
  props: {
    data: {
      type: Object,
      default: null,
    },
  },
  data() {
    return {
      ciModal: {
        open: false,
      },
    };
  },
  methods: {
    openCIModal() {
      this.ciModal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
      // Temporary solution to put nav behind modal when modal is active
      document.querySelector('.nav-hoc').style.zIndex = '0';
    },
    closeCIModal() {
      this.ciModal.open = false;
      // Temporary solution to show nav when modal is inactive
      document.querySelector('.nav-hoc').style.zIndex = '1025';
    },
  },
};
</script>

<template>
  <div class="platform-call-out slp-mt-64 slp-mb-48">
    <div v-if="data.additionalIcon">
      <svg
        width="38"
        height="33"
        viewBox="0 0 38 33"
        fill="none"
        xmlns="http://www.w3.org/2000/svg"
      >
        <path
          d="M33.0942 5.2503L32.7046 7.14561C32.5771 7.76269 32.0316 8.24124 31.3445 8.35458L29.2122 8.70091C28.8368 8.76387 28.8368 9.24242 29.2122 9.29909L31.3445 9.64542C32.0387 9.75876 32.5771 10.2436 32.7046 10.8544L33.0942 12.7497C33.165 13.0834 33.7034 13.0834 33.7671 12.7497L34.1568 10.8544C34.2843 10.2373 34.8297 9.75876 35.5169 9.64542L37.6491 9.29909C38.0245 9.23613 38.0245 8.75758 37.6491 8.70091L35.5169 8.35458C34.8226 8.24124 34.2843 7.7564 34.1568 7.14561L33.7671 5.2503C33.6963 4.91657 33.1579 4.91657 33.0942 5.2503Z"
          fill="url(#paint0_linear_448_7928)"
        />
        <path
          d="M10.3741 0.495272L9.68403 4.24563C9.45819 5.46667 8.49209 6.41361 7.27505 6.63789L3.49846 7.32317C2.83348 7.44776 2.83348 8.3947 3.49846 8.50683L7.27505 9.19211C8.50463 9.41639 9.45819 10.3758 9.68403 11.5844L10.3741 15.3347C10.4996 15.9951 11.4531 15.9951 11.566 15.3347L12.2561 11.5844C12.482 10.3633 13.4481 9.41639 14.6651 9.19211L18.4417 8.50683C19.1067 8.38224 19.1067 7.4353 18.4417 7.32317L14.6651 6.63789C13.4355 6.41361 12.482 5.45422 12.2561 4.24563L11.566 0.495272C11.4406 -0.165091 10.487 -0.165091 10.3741 0.495272Z"
          fill="url(#paint1_linear_448_7928)"
        />
        <path
          opacity="0.6"
          d="M21.475 17.437L20.8653 20.7484C20.667 21.8247 19.8247 22.6677 18.7483 22.8653L15.437 23.475C14.8543 23.5822 14.8543 24.4178 15.437 24.525L18.7483 25.1347C19.8247 25.333 20.6677 26.1753 20.8653 27.2516L21.475 30.563C21.5822 31.1457 22.4178 31.1457 22.525 30.563L23.1347 27.2516C23.333 26.1753 24.1753 25.3323 25.2516 25.1347L28.563 24.525C29.1457 24.4178 29.1457 23.5822 28.563 23.475L25.2516 22.8653C24.1753 22.667 23.3323 21.8247 23.1347 20.7484L22.525 17.437C22.4178 16.8543 21.5822 16.8543 21.475 17.437Z"
          fill="url(#paint2_linear_448_7928)"
        />
        <defs>
          <linearGradient
            id="paint0_linear_448_7928"
            x1="35.7577"
            y1="11.0748"
            x2="31.6493"
            y2="6.4528"
            gradientUnits="userSpaceOnUse"
          >
            <stop stop-color="#DF4329" stop-opacity="0.9" />
            <stop offset="0.786458" stop-color="#A686F2" />
          </linearGradient>
          <linearGradient
            id="paint1_linear_448_7928"
            x1="15.0917"
            y1="12.0205"
            x2="6.9059"
            y2="3.77741"
            gradientUnits="userSpaceOnUse"
          >
            <stop offset="0.33" stop-color="#10AEAE" stop-opacity="0.61" />
            <stop offset="0.43" stop-color="#1CB3B1" stop-opacity="0.66" />
            <stop offset="0.63" stop-color="#3BC0B9" stop-opacity="0.79" />
            <stop offset="0.91" stop-color="#6FD7C6" />
          </linearGradient>
          <linearGradient
            id="paint2_linear_448_7928"
            x1="25.6144"
            y1="27.6148"
            x2="18.3862"
            y2="20.3866"
            gradientUnits="userSpaceOnUse"
          >
            <stop offset="0.2358" stop-color="#A686F2" />
            <stop offset="0.3904" stop-color="#A382F0" stop-opacity="0.9779" />
            <stop offset="0.5326" stop-color="#9A77EB" stop-opacity="0.9575" />
            <stop offset="0.67" stop-color="#8A65E3" stop-opacity="0.9379" />
            <stop offset="0.8036" stop-color="#744AD7" stop-opacity="0.9188" />
            <stop offset="0.9349" stop-color="#5829C8" stop-opacity="0.9" />
          </linearGradient>
        </defs>
      </svg>
    </div>
    <SlpTypography
      tag="span"
      variant="heading5-bold"
      class="slp-mr-32 slp-ml-8"
    >
      {{ data.title }}
      <span class="gradient-header">{{ data.highlight }}</span>
    </SlpTypography>
    <SlpButton
      v-if="data.demo"
      variant="secondary"
      :data-ga-name="data.data_ga_name"
      :data-ga-location="data.data_ga_location"
      class="platform-call-out__button"
      @click.native="openCIModal"
    >
      <SlpIcon
        v-if="data.iconName"
        :icon="data.iconName"
        size="md"
        class="slp-mr-16 platform-call-out__icon"
      />
      {{ data.text }}
    </SlpButton>
    <SlpButton
      v-else
      variant="secondary"
      :href="data.externalUrl"
      :data-ga-name="data.data_ga_name"
      :data-ga-location="data.data_ga_location"
      class="platform-call-out__button"
    >
      <SlpIcon
        v-if="data.iconName"
        :icon="data.iconName"
        size="md"
        class="slp-mr-16 platform-call-out__icon"
      />
      {{ data.text }}
    </SlpButton>
    <DemoModal
      v-if="data.demo"
      v-show="ciModal.open"
      :data="data.demo"
      :visible="ciModal.open"
      @close="closeCIModal"
    >
    </DemoModal>
  </div>
</template>

<style lang="scss" scoped>
.platform-call-out {
  display: flex;
  background-color: #45424d80;
  border-radius: 8px;
  padding: 24px;
  flex-wrap: wrap;
  @media (min-width: $breakpoint-md) {
    flex-wrap: nowrap;
  }
  &__button {
    margin: auto;
    flex: 0 0 100%;
    margin-top: 32px;
    width: 100%;
    justify-content: center;
    @media (min-width: $breakpoint-md) {
      width: auto;
      margin-top: 0;
      flex: 0 0 auto;
    }
  }
  .gradient-header {
    background: linear-gradient(
      123deg,
      #f9a026 0%,
      #a686f2 45.5%,
      #592ac8 100%
    );
    -webkit-background-clip: text;
    background-clip: text;
    -webkit-text-fill-color: transparent;
  }
  &__icon {
    width: 24px;
    height: 24px;
  }
}
</style>
